// homme.cpp
// Bruno Bouzy
// 13 decembre 2001

#include "homme.h"

#include "femme.h"
#include "liste.h"

Liste * Homme::mesInstances = NULL;

/////////////////////////////////////////////////////////////////
Homme::Homme(char * n) : Individu(n) {
  mesInstances->ajouter(this);
  maFemme = NULL;
}

/////////////////////////////////////////////////////////////////
Homme::~Homme() {
  mesInstances->enlever(this);
}

/////////////////////////////////////////////////////////////////
void Homme::imprimerNom() {
  cout << "homme " << nom << endl;
}

/////////////////////////////////////////////////////////////////
void Homme::imprimerConjoint() {
  cout << "mon conjoint: ";
  if (maFemme) cout << maFemme->nom << endl;
  else cout << "null" << endl;
}

/////////////////////////////////////////////////////////////////
void Homme::direAMonConjointJeSuisMort()
{
  if (maFemme) maFemme->monHomme = NULL;
}



/////////////////////////////////////////////////////////////////
Homme * Homme::getInstance(char * n)
{
  Homme * i = (Homme*) mesInstances->premier();
  if (i==NULL) return NULL;
  if (strcmp(i->nom, n)==0) return i;
  for (;;) {
    i = (Homme*) mesInstances->prochain();
    if (i==NULL) return NULL;
    if (strcmp(i->nom, n)==0) return i;
  }
}

