// individu.cpp
// Bruno Bouzy
// 13 decembre 2001

#include "individu.h"

#include "homme.h"
#include "femme.h"
#include "liste.h"
#include "utile.h"

#include <iostream.h>
#include <stdlib.h>

Liste * Individu::mesInstances = NULL;

/////////////////////////////////////////////////////////////////
Individu::Individu(char * n) {
  strcpy(nom, n);
  monPere = NULL;
  maMere = NULL;
  mesFils = new Liste();
  mesFilles = new Liste();
  mesInstances->ajouter(this);
}

/////////////////////////////////////////////////////////////////
Individu::~Individu() {
  mesInstances->enlever(this);
  if (mesFilles) delete mesFilles;
  if (mesFils) delete mesFils;
}

/////////////////////////////////////////////////////////////////
void Individu::imprimerNom() {
  cout << "individu " << nom << endl;
}

/////////////////////////////////////////////////////////////////
void Individu::imprimer() {
  imprimerNom();
  imprimerConjoint();
  imprimerParents();
  imprimerEnfants();
}

/////////////////////////////////////////////////////////////////
void Individu::imprimerConjoint() {
  ;
}

/////////////////////////////////////////////////////////////////
void Individu::imprimerEnfants() {
  cout << "mes fils: "  << endl;
  mesFils->imprimerNom();
  cout << "mes filles: "  << endl;
  mesFilles->imprimerNom();
}
/////////////////////////////////////////////////////////////////
void Individu::imprimerParents() {
  cout << "mon pere: ";
  // question
  if (monPere) monPere->imprimerNom();
  cout << endl;
  cout << "ma mere: ";
  if (maMere) maMere->imprimerNom();
  cout << endl;
}

/////////////////////////////////////////////////////////////////
void Individu::naissance()
{
  char sh[TAILLE_NOM];
  cout << "nom pere ? ";
  cin >> sh;
  Homme * h = Homme::getInstance(sh);
  if (!h) {
    cout << "pas d'homme portant ce nom." << endl;
    return;
  }
  char sf[TAILLE_NOM];
  cout << "nom mere ? ";
  cin >> sf;
  Femme * f = Femme::getInstance(sf);
  if (!f) {
    cout << "pas de femme portant ce nom." << endl;
    return;
  }

  int a = random() % 2;
  cout << "a = " << a << endl;

  char s [TAILLE_NOM];
  nomHasard(s);
  cout << "s = <" << s << ">" << endl;

  Individu * enfant = NULL;

  switch(a) {
  case 0:
    cout << "naissance d'un garcon." << endl;
    enfant = new Homme(s);
    h->mesFils->ajouter(enfant);
    f->mesFils->ajouter(enfant);
    break;
  case 1:
    cout << "naissance d'une fille." << endl;
    enfant = new Femme(s);
    h->mesFilles->ajouter(enfant);
    f->mesFilles->ajouter(enfant);
    break;
  }

  enfant->monPere = h;
  enfant->maMere = f;
  
}

/////////////////////////////////////////////////////////////////
void Individu::mort()
{
  char s[TAILLE_NOM];
  cout << "nom ? ";
  cin >> s;
  Individu * i = getInstance(s);
  if (i) {
    // debut question
    if (i->monPere) i->monPere->tonEnfantEstMort(i);
    if (i->maMere) i->maMere->tonEnfantEstMort(i);
    i->direAMesFilsJeSuisMort();
    i->direAMesFillesJeSuisMort();
    i->direAMonConjointJeSuisMort();
    // fin de la question
    delete i;
    cout << "individu mort." << endl;
  }
  else cout << "pas d'individu portant ce nom." << endl;
}

/////////////////////////////////////////////////////////////////
void Individu::tonEnfantEstMort(Individu * i)
{
  mesFils->enlever(i);
  mesFilles->enlever(i);
}

/////////////////////////////////////////////////////////////////
void Individu::direAMesFilsJeSuisMort()
{
  Individu * i = (Individu*) mesFils->premier();
  if (i==NULL) return;
  if (i->monPere==this) i->monPere = NULL;
  if (i->maMere==this) i->maMere = NULL;
  for (;;) {
    i = (Individu*) mesFils->prochain();
    if (i==NULL) return;
    if (i->monPere==this) i->monPere = NULL;
    if (i->maMere==this) i->maMere = NULL;
  }
}

/////////////////////////////////////////////////////////////////
void Individu::direAMesFillesJeSuisMort()
{
  Individu * i = (Individu*) mesFilles->premier();
  if (i==NULL) return;
  if (i->monPere==this) i->monPere = NULL;
  if (i->maMere==this) i->maMere = NULL;
  for (;;) {
    i = (Individu*) mesFilles->prochain();
    if (i==NULL) return;
    if (i->monPere==this) i->monPere = NULL;
    if (i->maMere==this) i->maMere = NULL;
  }
}

/////////////////////////////////////////////////////////////////
void Individu::direAMonConjointJeSuisMort()
{
  ;
}


/////////////////////////////////////////////////////////////////
void Individu::mariage()
{
  char sh[TAILLE_NOM];
  cout << "nom homme ? ";
  cin >> sh;
  Homme * h = Homme::getInstance(sh);
  if (!h) {
    cout << "pas d'homme portant ce nom." << endl;
    return;
  }
  char sf[TAILLE_NOM];
  cout << "nom femme ? ";
  cin >> sf;
  Femme * f = Femme::getInstance(sf);
  if (!f) {
    cout << "pas de femme portant ce nom." << endl;
    return;
  }

  h->maFemme = f;
  f->monHomme = h;

  // question que mettre ici si l'un ou l'autre est deja marie.

  cout << "homme et femme maries." << endl;
}

/////////////////////////////////////////////////////////////////
void Individu::separation()
{
  char sh[TAILLE_NOM];
  cout << "nom homme ? ";
  cin >> sh;
  Homme * h = Homme::getInstance(sh);
  if (!h) {
    cout << "pas d'homme portant ce nom." << endl;
    return;
  }
  char sf[TAILLE_NOM];
  cout << "nom femme ? ";
  cin >> sf;
  Femme * f = Femme::getInstance(sf);
  if (!f) {
    cout << "pas de femme portant ce nom." << endl;
    return;
  }

  if (!h->maFemme) {
    cout << "cet homme n'est pas marie." << endl;
    return;
  }
  if (h->maFemme != f) {
    cout << "cet homme n'est pas marie avec cette femme." << endl;
    return;
  }
  if (!f->monHomme) {
    cout << "cet femme n'est pas mariee." << endl;
    return;
  }
  if (f->monHomme != h) {
    cout << "cette femme n'est pas mariee avec cet homme." << endl;
    return;
  }
  f->monHomme = NULL;
  h->maFemme = NULL;
  cout << "homme et femme divorces." << endl;
}

/////////////////////////////////////////////////////////////////
void Individu::imprimerTout()
{
  int n = 0;
  Individu * i = (Individu*) mesInstances->premier();
  if (i==NULL) return;
  cout << "-------- " << endl;
  cout << "INDIVIDU " << ++n << endl;
  i->imprimer();
  cout << "-------- " << endl;
  for (;;) {
    i = (Individu*) mesInstances->prochain();
    if (i==NULL) return;
    cout << "-------- " << endl;
    cout << "INDIVIDU " << ++n << endl;
    i->imprimer();
    cout << "-------- " << endl;
  }
}

/////////////////////////////////////////////////////////////////
Individu * Individu::getInstance(char * n)
{
  Individu * i = (Individu*) mesInstances->premier();
  if (i==NULL) return NULL;
  if (strcmp(i->nom, n)==0) return i;
  for (;;) {
    i = (Individu*) mesInstances->prochain();
    if (i==NULL) return NULL;
    if (strcmp(i->nom, n)==0) return i;
  }
}

