// liste.cpp
// Bruno Bouzy
// 7 decembre 2001

#include "liste.h"
#include "utile.h"
#include "objet.h"

#include <iostream.h>
#include <stdlib.h>

//#define DEBUG_LISTE
//#define NF_LISTE

int Liste::nombre = 0;
int Liste::octets = 0;

/////////////////////////////////////////////////////////////////////////
element::element() { suivant = NULL; contenu = NULL; }

/////////////////////////////////////////////////////////////////////////
element::~element() { }

////////////////////////////////////////////////////////////////////////
Liste::Liste()
{
  nombre++;
  debut = NULL;
  courant = debut;
  longueur = 0;
}

////////////////////////////////////////////////////////////////////////
Liste::~Liste()
{
  element * suiv;
  courant = debut;
  while (courant) {
      suiv = courant->suivant;
      delete courant;
      courant = suiv;
  }
  nombre--;
}

////////////////////////////////////////////////////////////////////////
void Liste::ajouter(Objet * chose )
{ 
  element * adel = new element();
  adel->suivant = debut;
  adel->contenu = chose;
  debut = adel;
  longueur++;
}


/////////////////////////////////////////////////////////////////////////
// cette fonction est la fonction la plus appelee du programme.
// elle verifie que 'chose' n'est pas deja dans la liste.
// Elle met 'chose' a la FIN de la liste.
/////////////////////////////////////////////////////////////////////////
int Liste::ou_logique(Objet * chose )
{
  element * pendant = debut;
  if (pendant==NULL) {
    pendant = new element();
    pendant->contenu = chose;
    longueur++;
    debut = pendant;
    // cout <<"Liste::ou_logique:" << endl;
    // cout <<"\tdebut NULL, chose inseree..." << endl;
    return 0;
  }
  for (;;) {
    if (pendant->contenu==chose) {
      // cout <<"Liste::ou_logique:" << endl;
      // cout <<"\tcontenu identique a chose trouve, chose rejetee..." << endl;
      return -1;
    }
    element * apres = pendant->suivant; 
    if (apres==NULL) {
      apres = new element();
      apres->contenu = chose;
      longueur++;
      pendant->suivant = apres;
      // cout <<"Liste::ou_logique:" << endl;
      // cout <<"\tchose non trouvee, chose inseree..." << endl;
      return 0;
    }
    else pendant = apres;
  }
}


/////////////////////////////////////////////////////////////////////////
int Liste::enlever(Objet * chose )
{
  element * pendant = debut;
  if (pendant==NULL) return -1;
  element * avant = NULL;
  while (pendant->contenu!=chose) {
    avant = pendant;
    pendant = pendant->suivant;
    if (pendant==NULL) return -1;
  }
  if (pendant==debut) debut = pendant->suivant;
  else avant->suivant = pendant->suivant;
  delete pendant;
  longueur--;
  return 0;
}


////////////////////////////////////////////////////////////////////////
void Liste::enlever_tout()
{
  Objet * chose = premier();
  while (chose) {
    enlever(chose);
    chose = premier();
  }
}


////////////////////////////////////////////////////////////////////////
void Liste::inverser()
{
  element * avant = debut;
  element * pendant;
  element * apres;
  if (avant) {
    pendant = avant->suivant;
    courant = pendant;
    avant->suivant = NULL;
  }
  else return; // la liste etait vide
  while (pendant) {
    apres = pendant->suivant; // on decale
    courant->suivant = avant; // on inverse
    avant = pendant;
    pendant = apres;
    courant = pendant;
  }
  debut = avant;
}


////////////////////////////////////////////////////////////////////////
////// des methodes qui font agir la liste instance sur une autre liste:
////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////
// la liste 'this' est mise dans l'ordre, a la fin de la liste 'l'.
//////////////////////////////////////////////////////////////////////
void Liste::ou_logique_liste(Liste * l) {
  Objet * chose = premier();
  while (chose) {
    l->ou_logique(chose);
    chose = prochain();
  }
}

////////////////////////////////////////////////////////////////////////
void Liste::ajouter_liste(Liste * l)
{
  Objet * chose = premier();
  while (chose) {
    l->ajouter(chose);
    chose = prochain();
  }
}

////////////////////////////////////////////////////////////////////////
void Liste::et_logique_liste(Liste * l)
{
  Liste * li = new Liste();
  l->ajouter_liste(li);
  l->enlever_tout();
  Objet * chose = premier();
  while (chose) {
    int r = li->rechercher(chose);
    if (r==0) l->ou_logique(chose);
    chose = prochain();
  }
  delete li;
}

////////////////////////////////////////////////////////////////////////
void Liste::enlever_liste(Liste * l)
{
  Objet * chose = premier();
  while (chose) {
    l->enlever(chose);
    chose = prochain();
  }
}

////////////////////////////////////////////////////////////////////////
///////// des methodes qui lisent la liste instance:
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
Objet * Liste::premier()
{
  courant = debut;
  if (courant) return courant->contenu;
  else return NULL;
}

////////////////////////////////////////////////////////////////////////
Objet * Liste::prochain()
{
  if (courant) {
    courant=courant->suivant;
    if (courant) return courant->contenu;
    else return NULL;
  }
  else return NULL;
}

/////////////////////////////////////////////////////////////////////////
Objet * Liste::dernier()
{
  if (longueur==0) return NULL;
  element * pendant = debut;
  if (pendant==NULL) return NULL;
  while (pendant->suivant) pendant = pendant->suivant; 
  return pendant->contenu;
}

/////////////////////////////////////////////////////////////////////////
int Liste::rechercher(Objet * chose )
{
  element * pendant = debut;
  if (pendant==NULL) return -1;
  while (pendant->contenu!=chose) {
    pendant = pendant->suivant; // on decale
    if (pendant==NULL) return -1;
    courant = pendant;
  }
  return 0;
}


////////////////////////////////////////////////////////////////////////
int Liste::inclus_dans(Liste * l)
{
  Objet * chose = premier();
  if (chose==NULL) return 0;
  if (l->rechercher(chose)==-1) return -1;
  for (;;) {
    chose = prochain();
    if (chose==NULL) return 0;
    if (l->rechercher(chose)==-1) return -1;
  }
}


////////////////////////////////////////////////////////////////////////
int Liste::identique_a(Liste * l)
{
  if (inclus_dans(l)==-1) return -1;
  if (l->inclus_dans(this)==-1) return -1;
  return 0;
}

////////////////////////////////////////////////////////////////////////
Objet * Liste::element_hasard()
{
  cout <<"Liste::element_hasard:\n";
  cout <<"\tErreur: fonction non faite.\n";
  return NULL;
}


////////////////////////////////////////////////////////////////////////
void Liste::imprimer()
{
  Objet * ptr = (Objet *) premier();
  if (ptr) ptr->imprimer();
  else return;
  for ( ;; ) {
    ptr = (Objet *) prochain();
    if (ptr) ptr->imprimer();
    else break;
  }
}

////////////////////////////////////////////////////////////////////////
void Liste::imprimerNom()
{
  Objet * ptr = (Objet *) premier();
  if (ptr) ptr->imprimerNom();
  else return;
  for ( ;; ) {
    ptr = (Objet *) prochain();
    if (ptr) ptr->imprimerNom();
    else break;
  }
}



////////////////////////////////////////////////////////////////////////
void Liste::fimprimer(ostream & f, int d, int ntab)
{
  ntab++;
  Objet * ptr = (Objet *) premier();
  if (ptr) ptr->fimprimer(f, d, ntab);
  else return;
  for ( ;; ) {
    ptr = (Objet *) prochain();
    if (ptr) ptr->fimprimer(f, d, ntab);
    else break;
  }
}

////////////////////////////////////////////////////////////////////////
void Liste::fafficher(ostream & f, int ntab)
{
  ntab++;
  Objet * ptr = (Objet *) premier();
  if (ptr) ptr->fafficher(f, ntab);
  else return;
  for ( ;; ) {
    ptr = (Objet *) prochain();
    if (ptr) ptr->fafficher(f, ntab);
    else return;
  }
}
