// liste.h
// Bruno Bouzy
// 7 decembre 2001

#ifndef LISTE_H
#define LISTE_H

#include <iostream.h>
#include "liste_m.h"

class Objet;

class element { public:
  element * suivant;
  Objet * contenu;
  element();
  ~element();
};

class Liste {
private:
  element * debut;
  element * courant;
public:
  static int octets;
  static int nombre;
  int longueur;

  Liste();
  ~Liste();

  void imprimerNom();
  void imprimer();
  void fimprimer(ostream &, int, int);
  void fafficher(ostream &, int);
  void ajouter(Objet *); 
  int ou_logique(Objet *); 
  int enlever(Objet *);
  void inverser();
  void enlever_tout();

///////// la liste instance agit sur une autre liste:

  void ou_logique_liste(Liste *);
  // recopie la liste instance dans la
  // liste argument sans vider la liste instance au prealable.

  void ajouter_liste(Liste *);
  // recopie la liste instance dans la
  // liste argument sans vider la liste instance au prealable et
  // sans verifier que les elements ajoutes existent deja.

  void et_logique_liste(Liste *);
  // met le ET logique des deux listes dans la liste argument.

  void enlever_liste(Liste *);
  // enleve la liste instance de la liste argument.

///////// des methodes qui lisent la liste instance:

  Objet * premier();
  Objet * prochain();
  Objet * dernier();
  int rechercher(Objet *);
  // recherche l'objet dans la liste.
  // si elle trouve, elle retourne 0 en laissant 'courant' pointe
  // sur cet objet. sinon, elle retourne -1.
  int inclus_dans(Liste *);
  // retourne 0 si la liste instance est inclus dans la liste arg.

  int identique_a(Liste *);
  Objet * element_hasard();
};

#endif
